// DlgProxy.cpp : implementation file
//

#include "stdafx.h"
#include "AutomationClient.h"
#include "DlgProxy.h"
#include "AutomationClientDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAutomationClientDlgAutoProxy

IMPLEMENT_DYNCREATE(CAutomationClientDlgAutoProxy, CCmdTarget)

CAutomationClientDlgAutoProxy::CAutomationClientDlgAutoProxy()
{
	EnableAutomation();
	
	// To keep the application running as long as an automation 
	//	object is active, the constructor calls AfxOleLockApp.
	AfxOleLockApp();

	// Get access to the dialog through the application's
	//  main window pointer.  Set the proxy's internal pointer
	//  to point to the dialog, and set the dialog's back pointer to
	//  this proxy.
	ASSERT (AfxGetApp()->m_pMainWnd != NULL);
	ASSERT_VALID (AfxGetApp()->m_pMainWnd);
	ASSERT_KINDOF(CAutomationClientDlg, AfxGetApp()->m_pMainWnd);
	m_pDialog = (CAutomationClientDlg*) AfxGetApp()->m_pMainWnd;
	m_pDialog->m_pAutoProxy = this;
}

CAutomationClientDlgAutoProxy::~CAutomationClientDlgAutoProxy()
{
	// To terminate the application when all objects created with
	// 	with automation, the destructor calls AfxOleUnlockApp.
	//  Among other things, this will destroy the main dialog
	if (m_pDialog != NULL)
		m_pDialog->m_pAutoProxy = NULL;
	AfxOleUnlockApp();
}

void CAutomationClientDlgAutoProxy::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(CAutomationClientDlgAutoProxy, CCmdTarget)
	//{{AFX_MSG_MAP(CAutomationClientDlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CAutomationClientDlgAutoProxy, CCmdTarget)
	//{{AFX_DISPATCH_MAP(CAutomationClientDlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IAutomationClient to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {9982BE3E-59F1-11D4-A015-080009EE62AA}
static const IID IID_IAutomationClient =
{ 0x9982be3e, 0x59f1, 0x11d4, { 0xa0, 0x15, 0x8, 0x0, 0x9, 0xee, 0x62, 0xaa } };

BEGIN_INTERFACE_MAP(CAutomationClientDlgAutoProxy, CCmdTarget)
	INTERFACE_PART(CAutomationClientDlgAutoProxy, IID_IAutomationClient, Dispatch)
END_INTERFACE_MAP()

// The IMPLEMENT_OLECREATE2 macro is defined in StdAfx.h of this project
// {9982BE3C-59F1-11D4-A015-080009EE62AA}
IMPLEMENT_OLECREATE2(CAutomationClientDlgAutoProxy, "AutomationClient.Application", 0x9982be3c, 0x59f1, 0x11d4, 0xa0, 0x15, 0x8, 0x0, 0x9, 0xee, 0x62, 0xaa)

/////////////////////////////////////////////////////////////////////////////
// CAutomationClientDlgAutoProxy message handlers
